#!/system/bin/sh
#by @风又音理neri
#程序路径
MODDIR=${0%/*}
DATABASEDIR="$MODDIR/etc"

while [ -z "$(getprop sys.boot_completed)" ];do
sleep 1
done

if [ -f /data/adb/magisk/busybox ];then
BUSYBOX_PATH=/data/adb/magisk/busybox
elif [ -f /data/adb/ksu/bin/busybox ];then
BUSYBOX_PATH=/data/adb/ksu/bin/busybox
fi

NERIBOXDIR="/data/adb/Neribox"
CONFIG_PATH="$NERIBOXDIR/config.ini"

CONFIG () {
if [ -n "$1" -a -z "$2" -a -z "$3" ];then
    cat $1
        elif [ -n "$1" -a -n "$2" -a -z "$3" ];then
            cat $1 | $BUSYBOX_PATH egrep "^$2=" | $BUSYBOX_PATH sed -n 's/.*=//g;$p'
        elif [ -n "$1" -a -n "$2" -a -n "$3" ];then
    $BUSYBOX_PATH sed -i "s|$2=.*|$2=$3|g" $1
fi
}

ALIST_BOOT_MODE="$(CONFIG $CONFIG_PATH ALIST_BOOT_MODE)"

ARIA2_BOOT_MODE="$(CONFIG $CONFIG_PATH ALIST_BOOT_MODE)"

LIGHTTPD_BOOT_MODE="$(CONFIG $CONFIG_PATH LIGHTTPD_BOOT_MODE)"

if [ "$ALIST_BOOT_MODE" = "true" ];
then
/system/bin/sh $MODDIR/toolkit alist start
fi

if [ "$ARIA2_BOOT_MODE" = "true" ];
then
/system/bin/sh $MODDIR/toolkit aria2 start
fi

while true;do
STOPPED=false
    while [ "$(dumpsys deviceidle get screen)" = "false" ];do
        AOD="$(CONFIG $CONFIG_PATH AOD)"
        if [ "$AOD" -gt "0" -a "$STOPPED"="false" ];then
            AOD_COUNT=0
                while [ "$AOD" -gt "$AOD_COUNT" ];do
                sleep 1
                AOD_COUNT=`$BUSYBOX_PATH expr $AOD_COUNT + 1`
                    if [ "$AOD_COUNT" -ge "$AOD" ];then
                    /system/bin/sh $MODDIR/toolkit alist stop
                    /system/bin/sh $MODDIR/toolkit aria2 stop
                    /system/bin/sh $MODDIR/toolkit lighttpd stop
                    /system/bin/sh $MODDIR/toolkit rclone umount
                    /system/bin/sh $MODDIR/toolkit frpc stop
                    STOPPED=true
                    break
                    elif [ "$(dumpsys deviceidle get screen)" = "true" ];then
                    STOPPED=false
                    break
                    fi
                done
        fi
        sleep 3
    done
    while [ "$(dumpsys deviceidle get screen)" = "true" ];do
        if [ "$(CONFIG $CONFIG_PATH DASHBOARD)" = "true" ];then
        /system/bin/sh $MODDIR/toolkit dashboard
        fi
        if [ "$(CONFIG $CONFIG_PATH LIGHTTPD_BOOT_MODE)" = "true" ];then
        ARIA2_PID="$($BUSYBOX_PATH ps | grep $MODDIR/bin/aria2c | grep -v -e "grep" -e "-v" | $BUSYBOX_PATH awk '{print $1}')"
        LIGHTTPD_PID="$($BUSYBOX_PATH ps | grep $MODDIR/bin/lighttpd | grep -v -e "grep" -e "-v" | $BUSYBOX_PATH awk '{print $1}')"
            if [ -z "$ARIA2_PID" -a -n "$LIGHTTPD_PID" ];then
            /system/bin/sh $MODDIR/toolkit lighttpd stop
            elif [ -n "$ARIA2_PID" -a -z "$LIGHTTPD_PID" ];then
            /system/bin/sh $MODDIR/toolkit lighttpd start
            fi
        fi
        if [ "$(CONFIG $CONFIG_PATH RCLONE_BOOT_MODE)" = "true" ];then
        ALIST_PID="$($BUSYBOX_PATH ps | grep "$MODDIR/bin/alist server --data $DATABASEDIR" | grep -v "grep" | $BUSYBOX_PATH awk '{print $1}')"
        RCLONE_PID="$($BUSYBOX_PATH ps | grep "$MODDIR/bin/rclone mount" | grep -v "grep" | $BUSYBOX_PATH awk '{print $1}')"
            if [ -z "$ALIST_PID" -a -n "$RCLONE_PID" ];then
            /system/bin/sh $MODDIR/toolkit rclone umount
            elif [ -n "$ALIST_PID" -a -z "$RCLONE_PID" ];then
            /system/bin/sh $MODDIR/toolkit rclone mount
            fi
        fi
        if [ "$(CONFIG $CONFIG_PATH FRPC_BOOT_MODE)" = "true" ];then
        ALIST_PID="$($BUSYBOX_PATH ps | grep "$MODDIR/bin/alist server --data $DATABASEDIR" | grep -v "grep" | $BUSYBOX_PATH awk '{print $1}')"
        FRPC_PID="$($BUSYBOX_PATH ps | grep $MODDIR/bin/frpc | grep -v -e "grep" -e "-v" | $BUSYBOX_PATH awk '{print $1}')"
            if [ -z "$ALIST_PID" -a -n "$FRPC_PID" ];then
            /system/bin/sh $MODDIR/toolkit frpc stop
            elif [ -n "$ALIST_PID" -a -z "$FRPC_PID" ];then
            /system/bin/sh $MODDIR/toolkit frpc start
            fi
        fi
    sleep 3
    done
done